using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using WindowsLive.Writer.Api;
using JTLeigh.Tools.CopySourceAsHtml;

namespace PasteCodeAndHtml
{
    [WriterPluginAttribute
   ("312B9353-44E0-45d0-BCCC-840FEABAF156",
    "Paste Code From Visual Studio",
    ImagePath = "Images.PasteCode.png",
    PublisherUrl = "http://www.west-wind.com/",
    Description = "Paste Code From Visual Studio")]

    [InsertableContentSourceAttribute("Visual Studio Code")]
    public class VsCodePlugin : ContentSource
    {
        public override DialogResult CreateContent(IWin32Window dialogOwner, ref string newContent)
        {
            DialogResult result = DialogResult.OK;
            if (System.Windows.Forms.Clipboard.ContainsText() == true)
            {                
                Copier rtfImporter = new Copier();
                newContent = rtfImporter.CopyAsHtml(System.Windows.Forms.Clipboard.GetText(TextDataFormat.Rtf)) + "<p></p>\r\n";                    
            }
            else
            {
                result = MessageBox.Show(dialogOwner, "Copy your HTML to the clipboard.", "Paste as Html", MessageBoxButtons.OKCancel);
                if (result == DialogResult.OK && System.Windows.Forms.Clipboard.ContainsText() == true)
                {
                    newContent = System.Windows.Forms.Clipboard.GetText();
                }
            }

            return result;
        }
    }
}
