// =================================================================================================
// CopySourceAsHtml
// 
// Copyright  2006 J.T. Leigh & Associates Inc.  All rights reserved.
// 
// Microsoft and Visual Studio are either trademarks or registered trademarks 
// Corporation.
// 
// THIS SOFTWARE IS PROVIDED "AS-IS," WITHOUT WARRANTY OF ANY KIND, AND ANY USE OF THIS SOFTWARE 
// PRODUCT IS AT YOUR OWN RISK.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, J.T. LEIGH &
// ASSOCIATES AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES AND CONDITIONS, EITHER EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY AND/OR 
// FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND NON-INFRINGEMENT, WITH REGARD TO THE SOFTWARE. 
// =================================================================================================

using System.Text;
using System.Windows.Forms;

namespace JTLeigh.Tools.CopySourceAsHtml
{

    internal static class Clipboard
    { 

        public static string GetRtf()
        {
            if (!System.Windows.Forms.Clipboard.ContainsText(TextDataFormat.Rtf))
            {
                return null;
            }
            return System.Windows.Forms.Clipboard.GetText(TextDataFormat.Rtf);
        }

        public static void SetHtml(string html)
        {

            DataObject data;

            data = new DataObject();
            data.SetData(DataFormats.Text, true, html);
            data.SetData(DataFormats.Html, true, EncodeHtml(html));
            System.Windows.Forms.Clipboard.SetDataObject(data, true);

        }

        private static string EncodeHtml(string html)
        {

            StringBuilder encodedHtml;
            int startHtml;
            int endHtml;
            int startFragment;
            int endFragment;

            encodedHtml = new StringBuilder();
            encodedHtml.Append("Version:0.9\n");
            encodedHtml.Append("StartHTML:aaaaaaaaaa\n");
            encodedHtml.Append("EndHTML:bbbbbbbbbb\n");
            encodedHtml.Append("StartFragment:cccccccccc\n");
            encodedHtml.Append("EndFragment:dddddddddd\n");
            startHtml = encodedHtml.Length;
            startFragment = encodedHtml.Length;
            encodedHtml.Append("<!--StartFragment-->\n");
            encodedHtml.Append(html);
            encodedHtml.Append("<!--EndFragment-->\n");
            endFragment = encodedHtml.Length;
            endHtml = encodedHtml.Length;
            encodedHtml.Replace("aaaaaaaaaa", startHtml.ToString("0000000000"), 0, startHtml);
            encodedHtml.Replace("bbbbbbbbbb", endHtml.ToString("0000000000"), 0, startHtml);
            encodedHtml.Replace("cccccccccc", startFragment.ToString("0000000000"), 0, startHtml);
            encodedHtml.Replace("dddddddddd", endFragment.ToString("0000000000"), 0, startHtml);
            return encodedHtml.ToString();

        }

    }

}
