// =================================================================================================
// CopySourceAsHtml
// 
// Copyright  2006 J.T. Leigh & Associates Inc.  All rights reserved.
// 
// Microsoft and Visual Studio are either trademarks or registered trademarks 
// Corporation.
// 
// THIS SOFTWARE IS PROVIDED "AS-IS," WITHOUT WARRANTY OF ANY KIND, AND ANY USE OF THIS SOFTWARE 
// PRODUCT IS AT YOUR OWN RISK.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, J.T. LEIGH &
// ASSOCIATES AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES AND CONDITIONS, EITHER EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY AND/OR 
// FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND NON-INFRINGEMENT, WITH REGARD TO THE SOFTWARE. 
// =================================================================================================

using System.Collections.Generic;

namespace JTLeigh.Tools.CopySourceAsHtml
{

    internal sealed class HtmlLine
    {

        private List<HtmlBlock> blockList;

        public HtmlLine()
        {
            this.blockList = new List<HtmlBlock>();
        }

        public void AddBlock(HtmlBlock block)
        {
            this.blockList.Add(block);
        }

        public bool HasContent
        {
            get
            {
                foreach (HtmlBlock block in this.blockList)
                {
                    if (block.HasContent)
                    {
                        return true;
                    }
                }
                return false;
            }
        }

        public int LeadingSpaces
        {
            get
            {

                int leadingSpaces;

                leadingSpaces = 0;
                foreach (HtmlBlock block in this.blockList)
                {
                    leadingSpaces += block.LeadingSpaces;
                    if (block.HasContent)
                    {
                        break;
                    }
                }
                return leadingSpaces;

            }
        }

        public List<HtmlBlock> Blocks
        {
            get { return this.blockList; }
        }

    }

}
