// =================================================================================================
// CopySourceAsHtml
// 
// Copyright  2006 J.T. Leigh & Associates Inc.  All rights reserved.
// 
// Microsoft and Visual Studio are either trademarks or registered trademarks 
// Corporation.
// 
// THIS SOFTWARE IS PROVIDED "AS-IS," WITHOUT WARRANTY OF ANY KIND, AND ANY USE OF THIS SOFTWARE 
// PRODUCT IS AT YOUR OWN RISK.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, J.T. LEIGH &
// ASSOCIATES AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES AND CONDITIONS, EITHER EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY AND/OR 
// FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND NON-INFRINGEMENT, WITH REGARD TO THE SOFTWARE. 
// =================================================================================================

using System;

namespace JTLeigh.Tools.CopySourceAsHtml
{

    public class HtmlStyle
    {

        private string style;

        public HtmlStyle()
        {
            this.style = "";
        }

        public void Append(string value)
        {
            if (this.style.Length > 0)
            {
                this.style += " ";
            }
            this.style += value.Trim();
        }

        public void AppendFormat(string format, params object[] arguments)
        {
            Append(String.Format(format, arguments));
        }

        public override string ToString()
        {
            return this.style;
        }

        public override bool Equals(object value)
        {
            return this.style.Equals(((HtmlStyle)value).style);
        }

        public override int GetHashCode()
        {
            return this.style.GetHashCode();
        }

        public int Length
        {
            get { return this.style.Length; }
        }

    }

}
